using System;
using System.Threading;

namespace Play
{
    public class Cryptographer
    {
        public static byte[] key1 = {
 								  0x45, 0x00, 0x00, 0x30, 0x77, 0x6B, 0x40, 0x00, 0x80, 0x06, 0x38, 0x67, 0xC0, 0xA8, 0x01, 0x65,
								  0x40, 0x97, 0x48, 0x51, 0x0E, 0x2A, 0x26, 0xE6, 0xBD, 0xEB, 0xAC, 0x20, 0x00, 0x00, 0x00, 0x00,
								  0x70, 0x02, 0xFF, 0xFF, 0x99, 0x0D, 0x00, 0x00, 0x02, 0x04, 0x05, 0xB4, 0x01, 0x01, 0x04, 0x02,
								  0x45, 0x00, 0x00, 0x28, 0x77, 0x6C, 0x40, 0x00, 0x80, 0x06, 0x38, 0x6E, 0xC0, 0xA8, 0x01, 0x65,
								  0x40, 0x97, 0x48, 0x51, 0x0E, 0x2A, 0x26, 0xE6, 0xBD, 0xEB, 0xAC, 0x21, 0xEB, 0xD6, 0x05, 0xC1,
								  0x50, 0x10, 0xFF, 0xFF, 0xD4, 0x29, 0x00, 0x00, 0x45, 0x00, 0x00, 0x30, 0x5C, 0x1E, 0x00, 0x00,
								  0x70, 0x06, 0xA3, 0xB4, 0x40, 0x97, 0x48, 0x51, 0xC0, 0xA8, 0x01, 0x65, 0x26, 0xE6, 0x0E, 0x2A,
								  0xEB, 0xD6, 0x05, 0xC0, 0xBD, 0xEB, 0xAC, 0x21, 0x70, 0x12, 0x44, 0x70, 0x62, 0xF5, 0x00, 0x00,
								  0x02, 0x04, 0x05, 0xB4, 0x01, 0x01, 0x04, 0x02, 0x45, 0x00, 0x01, 0x3C, 0x77, 0x6D, 0x40, 0x00,
								  0x80, 0x06, 0x37, 0x59, 0xC0, 0xA8, 0x01, 0x65, 0x40, 0x97, 0x48, 0x51, 0x0E, 0x2A, 0x26, 0xE6,
								  0xBD, 0xEB, 0xAC, 0x21, 0xEB, 0xD6, 0x05, 0xC1, 0x50, 0x18, 0xFF, 0xFF, 0x8A, 0x8D, 0x00, 0x00,
								  0x15, 0x94, 0x56, 0x65, 0xA5, 0x32, 0xE5, 0x04, 0x12, 0xC5, 0x7B, 0x61, 0x55, 0x8B, 0xB6, 0xF5,
								  0x5C, 0x0F, 0x33, 0xA5, 0x14, 0xCB, 0x75, 0x6F, 0x5F, 0x89, 0xB0, 0x22, 0x93, 0x46, 0xF6, 0xE3,
								  0xD6, 0x00, 0x3E, 0xA2, 0x17, 0xC4, 0x78, 0x6C, 0x56, 0x82, 0xBF, 0x2B, 0x92, 0x43, 0xF5, 0xE0,
								  0xD9, 0x05, 0x35, 0xAB, 0x16, 0xC1, 0x7F, 0x6D, 0x59, 0x87, 0xBA, 0x20, 0x9D, 0x4C, 0xF8, 0xE1,
								  0xD0, 0x0E, 0x30, 0xA0, 0x11, 0xC2, 0x72, 0x62, 0x50, 0x88, 0xB1, 0x29, 0x9C, 0x49, 0xFF, 0xE6,
								  0xDB, 0x03, 0x3F, 0xA9, 0x10, 0xCF, 0x71, 0x63, 0x5B, 0x8D, 0xBC, 0x26, 0x9F, 0x4A, 0xF2, 0xE7,
								  0xD2, 0x04, 0x3A, 0xA6, 0x13, 0xC8, 0x74, 0x60, 0x52, 0x86, 0xBB, 0x2F, 0x9E, 0x47, 0xF1, 0xE4,
								  0xD5, 0x09, 0x31, 0xAF, 0x12, 0xC5, 0x7B, 0x61, 0x55, 0x8B, 0xB6, 0x24, 0x99, 0x40, 0xF4, 0xE5,
								  0xDC, 0x02, 0x3C, 0xA4, 0x1D, 0xC6, 0x7E, 0x66, 0x5C, 0x8C, 0xBD, 0x2D, 0x09, 0x40, 0xD3, 0x1B,
								  0xF0, 0x7F, 0x51, 0xBC, 0x65, 0x8A, 0x83, 0xB7, 0xDA, 0x8F, 0x07, 0x0D, 0x9B, 0x4E, 0xFE, 0xEB,
								  0xDE, 0x08, 0x36, 0xAA, 0x1F, 0xCC, 0x70, 0x64, 0x5E, 0x8A, 0xB7, 0x23, 0x9A, 0x4B, 0xFD, 0xE8,
								  0xD1, 0x0D, 0x3D, 0xA3, 0x1E, 0xC9, 0x77, 0x65, 0x51, 0x8F, 0xB2, 0x28, 0x95, 0x44, 0xF0, 0xE9,
								  0xD8, 0x06, 0x38, 0xA8, 0x19, 0xCA, 0x7A, 0x6A, 0x58, 0x80, 0xB9, 0x21, 0x94, 0x41, 0xF7, 0xEE,
								  0xD3, 0x0B, 0x37, 0xA1, 0x18, 0xC7, 0x79, 0x6B, 0x53, 0x85, 0xB4, 0x2E, 0x97, 0x42, 0xFA, 0xEF,
								  0xDA, 0x0C, 0x32, 0xAE, 0x1B, 0xC0, 0x7C, 0x68, 0x5A, 0x8E, 0xB3, 0x27, 0x96, 0x4F, 0xF9, 0xEC,
								  0xDD, 0x01, 0x39, 0xA7, 0x1A, 0xCD, 0x73, 0x69, 0x5D, 0x83, 0xBE, 0x2C, 0x91, 0x48, 0xFC, 0xED,
								  0xD4, 0x0A, 0x34, 0xAC, 0x15, 0xCE, 0x76, 0x6E, 0x86, 0x56, 0x67, 0xF7, 0x47, 0x61, 0xE7, 0x26,
								  0x9B, 0xFA, 0xB7, 0x77, 0xC6, 0x19, 0xA7, 0xBD, 0x8D, 0x5B, 0x62, 0xF0, 0x66, 0x5C, 0x8C, 0xBD,
								  0x45, 0x00, 0x00, 0x28, 0x84, 0x90, 0x00, 0x00, 0x70, 0x06, 0x7B, 0x4A, 0x40, 0x97, 0x48, 0x51,
								  0xC0, 0xA8, 0x01, 0x65, 0x26, 0xE6, 0x0E, 0x2A, 0xEB, 0xD6, 0x05, 0xC1, 0xBD, 0xEB, 0xAD, 0x35,
								  0x50, 0x10, 0x43, 0x5C, 0x8F, 0xB9, 0x00, 0x00, 0xA1, 0x18, 0xC7, 0x79, 0x6B, 0x53, 0xB5, 0xE5,
								  0x45, 0x00, 0x00, 0x48, 0x84, 0x91, 0x00, 0x00, 0x70, 0x06, 0x7B, 0x29, 0x40, 0x97, 0x48, 0x51,
								  0xC0, 0xA8, 0x01, 0x65, 0x26, 0xE6, 0x0E, 0x2A, 0xEB, 0xD6, 0x05, 0xC1, 0xBD, 0xEB, 0xAD, 0x35,
								  0x50, 0x18, 0x43, 0x5C, 0x5D, 0x18, 0x00, 0x00, 0x47, 0x48, 0xAA, 0x12, 0xAA, 0x7A, 0x3F, 0x2E,
								  0xA1, 0x70, 0x33, 0x0E, 0x22, 0xFF, 0xB5, 0xE5, 0xA6, 0x8B, 0xE9, 0xA1, 0x4A, 0x86, 0x7C, 0x3D,
								  0xEE, 0x00, 0xE3, 0x2A, 0xFA, 0x2D, 0x87, 0xC6, 0xAD, 0xBF, 0x8B, 0x55, 0x68, 0xF2, 0x4F, 0x9E,
								  0x45, 0x00, 0x00, 0x78, 0x77, 0x6E, 0x40, 0x00, 0x80, 0x06, 0x38, 0x1C, 0xC0, 0xA8, 0x01, 0x65,
								  0x40, 0x97, 0x48, 0x51, 0x0E, 0x2A, 0x26, 0xE6, 0xBD, 0xEB, 0xAD, 0x35, 0xEB, 0xD6, 0x05, 0xE1,
								  0x50, 0x18, 0xFF, 0xDF, 0x58, 0xA5, 0x00, 0x00, 0x02, 0x94, 0xE0, 0x71, 0xA7, 0xFC, 0xEC, 0x70,
								  0xB6, 0x02, 0xD9, 0x2D, 0x87, 0x03, 0x09, 0xCA, 0x54, 0xB2, 0xB4, 0x31, 0x0B, 0xD7, 0xE7, 0x79,
								  0xC4, 0x13, 0xAD, 0xBF, 0x8B, 0x55, 0x68, 0xF2, 0x4F, 0x9E, 0x2A, 0x33, 0x02, 0xDC, 0xE2, 0x72,
								  0xC3, 0x10, 0xA0, 0xB0, 0x82, 0x5A, 0x63, 0xFB, 0x4E, 0x9B, 0x2D, 0x34, 0xC8, 0xD1, 0x2C, 0x3B,
								  0x61, 0x33, 0xA3, 0xB1, 0x27, 0x6F, 0x6E, 0xF4, 0x6A, 0xCE, 0x17, 0xD7, 0x46, 0xC0, 0xAF, 0x74,
								  0xC1, 0x1A, 0xA6, 0xB2, 0x80, 0x54, 0x69, 0xFD, 0xA1, 0x18, 0xC7, 0x79, 0x6B, 0xFA, 0x2D, 0x87,
								  0x45, 0x00, 0x00, 0x28, 0x77, 0x6F, 0x40, 0x00, 0x80, 0x06, 0x38, 0x6B, 0xC0, 0xA8, 0x01, 0x65,
								  0x40, 0x97, 0x48, 0x51, 0x0E, 0x2A, 0x26, 0xE6, 0xBD, 0xEB, 0xAD, 0x85, 0xEB, 0xD6, 0x05, 0xE1,
								  0x50, 0x11, 0xFF, 0xDF, 0xD2, 0xC4, 0x00, 0x00, 0x77, 0xC6, 0x19, 0xA7, 0xBD, 0x8D, 0x5B, 0x62,
								  0x45, 0x00, 0x00, 0x34, 0x5C, 0x35, 0x00, 0x00, 0x70, 0x06, 0xA3, 0x99, 0x40, 0x97, 0x48, 0x51,
								  0xC0, 0xA8, 0x01, 0x65, 0x26, 0xE6, 0x0E, 0x2A, 0xEB, 0xD6, 0x05, 0xE1, 0xBD, 0xEB, 0xAD, 0x35,
								  0x80, 0x10, 0x43, 0x5C, 0x82, 0x9E, 0x00, 0x00, 0x01, 0x01, 0x05, 0x0A, 0xBD, 0xEB, 0xAD, 0x85,
								  0xBD, 0xEB, 0xAD, 0x86, 0x50, 0x18, 0x43, 0x5C, 0x5D, 0x18, 0x00, 0x00, 0x47, 0x48, 0xAA, 0x12,
								  0x45, 0x00, 0x00, 0x28, 0x5C, 0x36, 0x00, 0x00, 0x70, 0x06, 0xA3, 0xA4, 0x40, 0x97, 0x48, 0x51,
								  0xC0, 0xA8, 0x01, 0x65, 0x26, 0xE6, 0x0E, 0x2A, 0xEB, 0xD6, 0x05, 0xE1, 0xBD, 0xEB, 0xAD, 0x86,
								  0x50, 0x10, 0x43, 0x0C, 0x8F, 0x98, 0x00, 0x00, 0x26, 0x00, 0x00, 0xA5, 0x42, 0xDA, 0x70, 0x5A,
								  0x45, 0x00, 0x05, 0x57, 0x84, 0x99, 0x40, 0x00, 0x70, 0x06, 0x26, 0xF7, 0x40, 0x97, 0x57, 0x6C,
								  0xC0, 0xA8, 0x01, 0x65, 0x16, 0xB8, 0x0E, 0x2B, 0x96, 0x63, 0x66, 0x24, 0xD4, 0xBB, 0x56, 0x50,
								  0x50, 0x18, 0x43, 0x87, 0x90, 0x26, 0x00, 0x00, 0xA5, 0x42, 0xDA, 0xD4, 0x44, 0x27, 0x0A, 0xB3,
								  0xC0, 0xF2, 0xF2, 0xE0, 0x7D, 0x85, 0xEE, 0x53, 0x92, 0x68, 0xE3, 0x5A, 0x01, 0xAE, 0x97, 0x24,
								  0xA9, 0xE9, 0xBA, 0x21, 0x0D, 0x5C, 0x91, 0xF1, 0x39, 0xB0, 0xB7, 0x12, 0x15, 0x56, 0xD7, 0xAB,
								  0xEB, 0xC3, 0x5C, 0x1E, 0x5D, 0xF6, 0x28, 0x43, 0x46, 0xAF, 0x7A, 0x81, 0xEE, 0x50, 0x22, 0x07,
								  0x2B, 0xB4, 0xCA, 0xF1, 0x5B, 0xCD, 0xA6, 0x43, 0x68, 0xCF, 0x60, 0x2A, 0x70, 0x11, 0xB8, 0x96,
								  0x3D, 0x22, 0xE5, 0x98, 0x97, 0x64, 0x55, 0x6A, 0x36, 0x33, 0xCD, 0x08, 0xF5, 0x68, 0x55, 0xC5,
								  0x86, 0x2F, 0x27, 0xA5, 0x7A, 0xE9, 0xE2, 0xD5, 0x7C, 0xC0, 0xA9, 0x92, 0x34, 0x13, 0x56, 0xE3,
								  0xF8, 0x7E, 0x70, 0xC9, 0x25, 0x42, 0xB7, 0x05, 0x6C, 0xD9, 0x4C, 0x3D, 0x4C, 0x74, 0x9B, 0xF5,
								  0xF6, 0xC0, 0x92, 0x34, 0x37, 0x66, 0x22, 0xC0, 0x17, 0xF3, 0xA5, 0xF1, 0x45, 0x72, 0xB6, 0x3C,
								  0x04, 0x98, 0x52, 0xE2, 0xB9, 0xDA, 0x42, 0x0C, 0x0D, 0x53, 0xB3, 0xDD, 0xDD, 0x24, 0xA6, 0x28,
								  0x51, 0x9A, 0x6B, 0xCB, 0x7E, 0x2E, 0x2B, 0x48, 0x2A, 0x39, 0x19, 0xC0, 0xFF, 0xD1, 0xA0, 0x74,
								  0x5B, 0xA8, 0xA6, 0x30, 0x85, 0xC6, 0xC1, 0x17, 0x73, 0x97, 0x69, 0x07, 0x1E, 0xFA, 0xAD, 0x57,
								  0x64, 0x8D, 0x19, 0x7A, 0xF7, 0xA6, 0xF0, 0xB1, 0x96, 0xB6, 0xB4, 0x1F, 0xB2, 0x2D, 0x57, 0x8E,
								  0xAD, 0x85, 0xAC, 0xEB, 0xB8, 0x52, 0x79, 0xC6, 0xE3, 0xB5, 0x09, 0x17, 0x28, 0x0C, 0x6E, 0x18,
								  0x53, 0xE0, 0x56, 0xCF, 0x6D, 0x71, 0xE4, 0x6A, 0xD9, 0x2E, 0x5F, 0x3E, 0xC7, 0x33, 0x5D, 0x78,
								  0x1F, 0x4A, 0xCA, 0x95, 0x66, 0x77, 0x7C, 0x12, 0x04, 0x84, 0x9A, 0x57, 0xBE, 0xEA, 0xC0, 0x4F,
								  0x43, 0x90, 0xEB, 0x17, 0x05, 0xDB, 0x97, 0xA1, 0x7B, 0xBD, 0x3D, 0x3C, 0x77, 0x6A, 0x7F, 0x1A,
								  0xE5, 0xF5, 0x02, 0x5A, 0x0B, 0x54, 0x8B, 0x15, 0x0E, 0x61, 0x80, 0xD8, 0xBF, 0x91, 0x1F, 0x2D,
								  0x67, 0x02, 0x0A, 0xCA, 0xDF, 0x5D, 0xB0, 0x0C, 0xFB, 0x0A, 0x57, 0xD8, 0xC0, 0x29, 0x71, 0xDD,
								  0x92, 0x6A, 0xFA, 0xC6, 0x9E, 0xFE, 0x39, 0xF2, 0x36, 0x0F, 0x89, 0xB0, 0x2C, 0x01, 0x61, 0x68,
								  0x43, 0xB2, 0xB2, 0x44, 0x61, 0xDB, 0x68, 0x28, 0x5C, 0x93, 0x94, 0x9E, 0xC9, 0x79, 0xAE, 0x93,
								  0x49, 0x7E, 0xA4, 0xAB, 0xB3, 0x4F, 0xC1, 0x70, 0x73, 0xF5, 0xAC, 0x6E, 0x31, 0x04, 0xAF, 0xCB,
								  0xED, 0x4C, 0x11, 0xCB, 0xC9, 0xCD, 0x75, 0x09, 0xEC, 0x04, 0x5C, 0xD4, 0x15, 0x2E, 0xA0, 0x16,
								  0x14, 0x64, 0x3E, 0x12, 0xFB, 0xE8, 0xED, 0x5E, 0x6F, 0xE5, 0x88, 0x56, 0xAF, 0xFA, 0x07, 0x44,
								  0xB2, 0xE9, 0x17, 0x92, 0x22, 0x15, 0x1B, 0x4A, 0xCC, 0xC3, 0xAA, 0xE3, 0x1D, 0xFE, 0xEA, 0x93,
								  0x9C, 0x88, 0x3E, 0x3A, 0xBE, 0x9F, 0x1C, 0x15, 0xDC, 0x4C, 0x1F, 0x8A, 0xE8, 0x28, 0xB6, 0xBA,
								  0x86, 0xFE, 0x56, 0x3E, 0xE0, 0x5F, 0xA2, 0x0E, 0x11, 0xB4, 0xDA, 0x5F, 0xBF, 0x74, 0xEC, 0xA3,
								  0x63, 0x37, 0xA9, 0x8A, 0x57, 0x03, 0xDE, 0xBE, 0x16, 0xF1, 0xA5, 0x51, 0xC5, 0xE4, 0x72, 0x09,
								  0x91, 0x8E, 0xE7, 0xBA, 0x87, 0x8A, 0x3F, 0x58, 0xEA, 0x32, 0x28, 0xAE, 0x49, 0xF1, 0x4B, 0x53,
								  0x81, 0x8E, 0x84, 0x0E, 0x5A, 0xFE, 0xAF, 0xCF, 0x94, 0x55, 0x3B, 0xB6, 0x96, 0x00, 0x58, 0x7A,
								  0x40, 0x5D, 0x03, 0x59, 0x0F, 0x22, 0x40, 0xE1, 0x08, 0x19, 0xD2, 0xB8, 0x61, 0x28, 0xC9, 0x17,
								  0xB0, 0xD9, 0x93, 0xDB, 0x73, 0xF7, 0x04, 0x38, 0x23, 0xA9, 0x95, 0xFC, 0x08, 0x2F, 0xCE, 0xD9,
								  0x5C, 0x5A, 0x40, 0x49, 0x9E, 0x52, 0x43, 0x25, 0x06, 0x81, 0xB0, 0x81, 0x87, 0xEC, 0x23, 0x6F,
								  0x9F, 0x4C, 0x39, 0x2C, 0x96, 0x1F, 0x52, 0xB2, 0x08, 0xB0, 0xD0, 0xD2, 0x4D, 0x90, 0x98, 0xC9,
								  0xBF, 0x64, 0x77, 0xD7, 0xC4, 0x86, 0xDE, 0xD4, 0xBA, 0x6B, 0x22, 0x85, 0x4D, 0xCB, 0x9C, 0x54,
								  0xE1, 0x67, 0x36, 0x0D, 0xFA, 0x16, 0x7C, 0xC5, 0x31, 0xE5, 0x1C, 0x49, 0x66, 0x3B, 0x14, 0xAF,
								  0x1B, 0x55, 0x4E, 0x66, 0x37, 0x6C, 0x10, 0x76, 0x33, 0x4E, 0x09, 0x67, 0x0C, 0x2C, 0x29, 0xB8,
								  0xE4, 0x80, 0x7B, 0x6C, 0xF2, 0x97, 0xB5, 0xFB, 0x63, 0xD6, 0x3A, 0x4F, 0x3F, 0x5C, 0x08, 0x5E,
								  0x9D, 0x2A, 0x51, 0xBA, 0x4A, 0x4B, 0x65, 0xC1, 0xD3, 0xA2, 0xC1, 0xE5, 0xD2, 0x5E, 0x8F, 0x2D,
								  0x0F, 0x55, 0x1D, 0xA2, 0x5E, 0xEC, 0xB8, 0xBB, 0xA1, 0x2A, 0x3D, 0xC9, 0x55, 0xCF, 0x80, 0x85,
								  0xEF, 0xCA, 0xF6, 0xB3, 0xE6, 0x09, 0x8D, 0x61, 0x1F, 0xF7, 0xA7, 0xB5, 0xC8, 0xA2, 0x90, 0xFC,
								  0xC8, 0xCC, 0x46, 0xAA, 0x59, 0xD6, 0x9F, 0x67, 0xC5, 0x8A, 0xBE, 0xB0, 0x98, 0x0D, 0xCE, 0xD9,
								  0x2E, 0x75, 0x49, 0x4C, 0x86, 0x63, 0x79, 0x7C, 0x1E, 0x6A, 0xCB, 0x6A, 0x0E, 0x57, 0xF9, 0x9B,
								  0x19, 0xEB, 0x95, 0x91, 0xC5, 0x2C, 0xAD, 0x2C, 0xB0, 0xB7, 0xDE, 0xAC, 0x01, 0x40, 0xE5, 0x92,
								  0x07, 0x31, 0x48, 0x89, 0xB2, 0x1F, 0xDC, 0xB8, 0x2C, 0x22, 0xD6, 0xEE, 0xEF, 0x61, 0x5F, 0x1C,
								  0x53, 0x0E, 0xC7, 0x5E, 0x38, 0xCA, 0xCC, 0xD4, 0x12, 0x53, 0x1A, 0x18, 0xB5, 0xB9, 0x39, 0x03,
								  0xAD, 0x56, 0x1F, 0xD5, 0xDC, 0xA3, 0xA5, 0xBA, 0x1D, 0xC6, 0x09, 0xA0, 0xA1, 0xD8, 0x3F, 0x76,
								  0xDE, 0x5F, 0x56, 0x55, 0x58, 0x6F, 0xE6, 0x36, 0xA2, 0x93, 0x28, 0x65, 0x13, 0xA7, 0x5A, 0x56,
								  0xE4, 0x73, 0x5B, 0x0A, 0x95, 0xBE, 0x8D, 0xB8, 0x19, 0xB2, 0xDF, 0x75, 0x92, 0x26, 0x9B, 0xAF,
								  0x8D, 0x0A, 0x7B, 0x3C, 0xCC, 0x03, 0xBA, 0xEA, 0xB2, 0xA1, 0xDB, 0x07, 0x92, 0x20, 0x9D, 0x8A,
								  0xE6, 0xE2, 0xD9, 0xF0, 0x37, 0xF0, 0x11, 0xAD, 0xAF, 0xB0, 0x56, 0x81, 0xB4, 0x53, 0x2C, 0x5C,
								  0x43, 0x6C, 0x3C, 0x6B, 0xB4, 0xF4, 0xB2, 0x34, 0x75, 0xD4, 0x29, 0x00, 0x09, 0xEE, 0x45, 0x2F,
								  0xD3, 0x7E, 0x48, 0x88, 0x9C, 0x70, 0x60, 0x08, 0xBE, 0xD9, 0x5C, 0xC2, 0x50, 0xC6, 0xD9, 0x50,
								  0x19, 0xA4, 0x61, 0xC5, 0x7B, 0x8A, 0x5A, 0x6E, 0x67, 0x59, 0xE8, 0xA7, 0xDA, 0x14, 0x25, 0x63,
								  0xCF, 0xAD, 0xD1, 0xC6, 0x94, 0x40, 0x4F, 0xC2, 0x02, 0x99, 0x00, 0x25, 0xE3, 0x2A, 0xD1, 0x97,
								  0x23, 0x92, 0xBA, 0x8B, 0x72, 0x2D, 0xAA, 0xDA, 0x1E, 0x7E, 0x7B, 0x74, 0xAB, 0x3B, 0xDC, 0xF5,
								  0x93, 0x7D, 0x54, 0xE3, 0x78, 0x59, 0xA6, 0x39, 0x42, 0x6A, 0xF8, 0x0F, 0x3C, 0x27, 0x05, 0xD2,
								  0x2F, 0x0C, 0x31, 0x1C, 0xA6, 0xD8, 0x47, 0xE9, 0xDA, 0x9F, 0x4A, 0x9D, 0xFF, 0xB8, 0x25, 0xF9,
								  0xCE, 0xA0, 0xC1, 0x1A, 0x07, 0xE1, 0x29, 0xB6, 0x6F, 0xC7, 0x16, 0xB9, 0x04, 0x05, 0xBC, 0xBD,
								  0xE7, 0xD6, 0x1A, 0x54, 0x21, 0xFE, 0x13, 0x3A, 0x66, 0xF4, 0x28, 0xBC, 0x48, 0xC8, 0x66, 0xBA,
								  0x3E, 0x7D, 0x65, 0x6B, 0xE0, 0x20, 0x37, 0x7C, 0xC2, 0x83, 0x19, 0xC7, 0x25, 0xFE, 0x99, 0x3A,
								  0x5C, 0x40, 0x73, 0x77, 0x65, 0x9C, 0x5A, 0x52, 0xCA, 0xBE, 0xDC, 0x06, 0x46, 0x17, 0x6A, 0xD9,
								  0x49, 0xA8, 0x8B, 0x82, 0x17, 0x7E, 0x30, 0x3B, 0xA3, 0x75, 0x36, 0x48, 0x7F, 0x7A, 0xC2, 0x48,
								  0x6B, 0x1E, 0x62, 0xED, 0x7E, 0xAC, 0x7A, 0x5E, 0xF2, 0xC1, 0xCA, 0xF6, 0xFF, 0xEB, 0x14, 0x8A,
								  0xCB, 0x72, 0xC1, 0xF7, 0x9D, 0x6C, 0x0D, 0xA4, 0x6D, 0x35, 0x93, 0x1A, 0xB0, 0xB2, 0x80, 0xE5,
								  0x0A, 0x33, 0x4C, 0x23, 0x6A, 0x2D, 0x38, 0xC9, 0x71, 0xA5, 0xDC, 0x8A, 0x73, 0xF2, 0x65, 0x9C,
								  0xE0, 0x1B, 0x1B, 0x26, 0x8E, 0x35, 0xFD, 0x1C, 0x58, 0x68, 0x86, 0xEA, 0xBF, 0x48, 0x24, 0x38,
								  0xA9, 0xB4, 0xEE, 0x16, 0x86, 0x7B, 0x0D, 0xA8, 0x82, 0xEC, 0xE4, 0xA0, 0xED, 0x10, 0xB2, 0x9A,
								  0x4C, 0x64, 0x1B, 0x00, 0x8B, 0x4E, 0xB0, 0x4A, 0x4D, 0x4B, 0xFF, 0x9D, 0xA6, 0x9F, 0xEB, 0x05,
								  0x0D, 0x46, 0xC8, 0x19, 0xB9, 0x59, 0x1D, 0xDA, 0x0D, 0x95, 0x46, 0x66, 0x85, 0xA7, 0x95, 0xE5,
								  0x56, 0xEE, 0x4C, 0x33, 0x6C, 0x17, 0x61, 0x13, 0x8A, 0x97, 0x29, 0xD1, 0xD3, 0xF0, 0x87, 0xDE,
								  0xC8, 0x33, 0x49, 0x44, 0xBD, 0x51, 0x80, 0x32, 0xBA, 0x87, 0x60, 0xE6, 0x31, 0x9C, 0xD0, 0x53,
								  0xFF, 0x07, 0x79, 0xAA, 0x67, 0xEC, 0xB8, 0xA1, 0xB8, 0x0F, 0xF6, 0xCB, 0x1B, 0xFA, 0x90, 0x8F,
								  0x7C, 0x4D, 0xB7, 0xB8, 0xCA, 0xF5, 0x38, 0xC5, 0xB1, 0x29, 0x2D, 0x43, 0x4A, 0x34, 0x20, 0x2B,
								  0xE5, 0x03, 0x1C, 0x10, 0x9D, 0x8C, 0x10, 0xA0, 0x81, 0xCD, 0x39, 0x7C, 0xA2, 0x24, 0x83, 0x8F,
								  0xA7, 0xB1, 0xB1, 0xE9, 0xAE, 0x86, 0xC1, 0x7C, 0x66, 0x33, 0x06, 0x03, 0x51, 0x58, 0x39, 0x56,
								  0x33, 0x13, 0xFB, 0x8E, 0xDF, 0x9F, 0xEB, 0x5E, 0x82, 0xA6, 0x3A, 0x10, 0x81, 0xE3, 0x38, 0x47,
								  0x57, 0xE8, 0x8D, 0xC8, 0xE4, 0xC8, 0xA4, 0x70, 0x20, 0xE6, 0x2C, 0x50, 0x8A, 0xE4, 0xCF, 0xC8,
								  0x8C, 0xC0, 0x53, 0xCF, 0x06, 0xDB, 0x8E, 0x0D, 0xAA, 0x91, 0x36, 0xF4, 0x02, 0xD6, 0x2B, 0x29,
								  0x40, 0xC6, 0x49, 0x2D, 0xB6, 0x70, 0x7C, 0x42, 0x83, 0x33, 0x29, 0x31, 0x38, 0xB3, 0xD5, 0x6F,
								  0xD8, 0x24, 0xEC, 0x09, 0x77, 0xFC, 0x83, 0x10, 0xD8, 0x95, 0x7B, 0x4D, 0x21, 0xEF, 0xF6, 0x39,
								  0x22, 0xC0, 0x3E, 0xC5, 0xB5, 0x50, 0x10, 0x38, 0x67, 0x0B, 0x46, 0x2B, 0x25, 0xD4, 0x70, 0xED,
								  0x1F, 0xFC, 0x9A, 0xE0, 0x77, 0xE1, 0x88, 0xDD, 0x43, 0xC8, 0x1F, 0x3B, 0xE0, 0x0F, 0x27, 0xC1,
								  0x94, 0xAA, 0xF9, 0x2F, 0xDD, 0xA5, 0xC7, 0xCA, 0xF5, 0x38, 0xC5, 0xB1, 0x29, 0x91, 0x36, 0xF4};


        public static void Decrypt(ref byte[] bytes)
        {
            if (bytes.Length < 0)
                return;
            int i = 0;
            byte t1 = 0;
            int t2;
            while (i < bytes.Length)
            {
                t1 = (byte)(bytes[i] ^ key1[(byte)i % 0x80]);
                t2 = i % 0x8;
                bytes[i] = (byte)((t1 << (0x8 - t2)) + (t1 >> t2));
                i++;
            }
        }
        public static void Encrypt(ref byte[] bytes)
        {
            if (bytes.Length < 0)
                return;
            int i = 0;
            byte t1 = 0;
            int t2;
            while (i < bytes.Length)
            {
                t2 = i % 0x8;
                t1 = (byte)((bytes[i] >> (0x8 - t2)) + (bytes[i] << t2));
                bytes[i] = (byte)(t1 ^ key1[(byte)i % 0x80]);
                i++;
            }
        }
    }
}
